/*! \mainpage The Cubi query builder
 *
 * \section intro_sec Introduction
 *
 * Cubi is a Sparql query builder built following the KISS (Keep It Simple,
 * Stupid) paradigm. That means Cubi will generate queries, period. It will
 * not check for the semantic validity of your queries, nor it will walk your
 * dog or make you coffee.
 *
 * Cubi's API tries to be minimal and easy to understand, while being flexible
 * enough to cover the full SPARQL and SPARQL/Update specification.
 *
 * Cubi now also includes a small tool called cubi-oc, the Cubi
 * ontology-compiler. See \ref ontocompiler_page for more information.
 *
 * If you ever had a doubt or a question concerning Cubi, then you can send an
 * email to adrien AT bustany DOT org .
 *
 * Cubi is released under the GNU LGPL license.
 *
 * \section technical_facts_sec Technical facts
 * All the classes in Cubi use implicit sharing, which means passing around
 * instances is very cheap. A real (deep) copy of a class' data will only
 * happen if the instance is modified from its original version (copy-on-write).
 *
 * \section implicit_explicit_ctors_sec Implicit/explicit constructors
 * By default, Cubi classes don't have explicit constructors. That allows you
 * to uses methods like PatternGroup::setFilter on a Function object directly
 * for example. However, if you wish to enable explicit constructors, you can
 * define the CUBI_EXPLICIT_CONSTRUCTORS flag when compiling your program.
 *
 */
