#!/bin/sh
set -e

cd $(dirname $0)

TESTS=$(find tests/auto -mindepth 1 -maxdepth 1 -type d -printf '%P\n')

echo "This will git clean, you have 5 seconds to abort"
sleep 5

git clean -dfx
./autogen.sh --enable-gcov
make -j5

mkdir -p coverage
lcov -c -i -d . -o coverage/app_base.info

CONCAT_COMMAND="lcov -a coverage/app_base.info"

for i in $TESTS; do
	./tests/auto/$i/$i
	lcov -c -d . -t "$i" -o coverage/app_test_$i.info
	CONCAT_COMMAND="$CONCAT_COMMAND -a coverage/app_test_$i.info"
done

CONCAT_COMMAND="$CONCAT_COMMAND -o coverage/app_total.info"

$CONCAT_COMMAND

cd coverage
mkdir -p html
genhtml -b app_base.info -s -o html --demangle-cpp app_total.info
