/****************************************************************************
 ** This file is part of Cubi, a Sparql query builder for the Qt framework
 **
 ** Copyright (c) 2010-2011 Nokia Corporation and/or its subsidiary(-ies).
 **
 ** Contact: Nokia Corporation (info@qt.nokia.com)
 **
 **
 ** GNU Lesser General Public License Usage
 **
 ** This file may be used under the terms of the GNU Lesser General Public
 ** License version 2.1 as published by the Free Software Foundation and
 ** appearing in the file LICENSE.LGPL included in the packaging of this file.
 ** Please review the following information to ensure the GNU Lesser General
 ** Public License version 2.1 requirements will be met:
 ** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
 **
 ** In addition, as a special exception, Nokia gives you certain additional
 ** rights. These rights are described in the Nokia Qt LGPL Exception
 ** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
 **
 ** Other Usage
 **
 ** Alternatively, this file may be used in accordance with the terms and
 ** conditions contained in a signed written agreement between you and Nokia.
 **
 ** If you have questions regarding the use of this file, please contact
 ** Nokia at info@qt.nokia.com.
 ****************************************************************************/

#ifndef CUBI_GLOBAL_H
#define CUBI_GLOBAL_H

#define CUBI_NAMESPACE Cubi

#define CUBI_BEGIN_NAMESPACE namespace CUBI_NAMESPACE {
#define CUBI_END_NAMESPACE }
#define CUBI_USE_NAMESPACE using namespace CUBI_NAMESPACE;

#ifdef CUBI_EXPLICIT_CONSTRUCTORS
#define CUBI_EXPLICIT explicit
#else
#define CUBI_EXPLICIT
#endif

#include <QObject>

CUBI_BEGIN_NAMESPACE

#ifndef Q_MOC_RUN
namespace
#else
class : public QObject
#endif
Options
{

#if defined(Q_MOC_RUN)
	Q_OBJECT

	Q_FLAGS(SparqlOption SparqlOptions)

public:
#endif
	enum SparqlOption {
		NoOptimization          = 0x0,
		RemoveDuplicates        = 0x1,
		NestOptionals           = 0x2,
		PrettyPrint             = 0x4,
		GroupPatterns           = 0x8
	};
	Q_DECLARE_FLAGS(SparqlOptions, SparqlOption)

	static SparqlOptions DefaultSparqlOptions = (SparqlOption)(RemoveDuplicates | NestOptionals | GroupPatterns);
}

#if defined(Q_MOC_RUN)
;
#endif

Q_DECLARE_OPERATORS_FOR_FLAGS(Options::SparqlOptions)

CUBI_END_NAMESPACE

#endif
