/****************************************************************************
 ** This file is part of Cubi, a Sparql query builder for the Qt framework
 **
 ** Copyright (c) 2010-2011 Nokia Corporation and/or its subsidiary(-ies).
 **
 ** Contact: Nokia Corporation (info@qt.nokia.com)
 **
 **
 ** GNU Lesser General Public License Usage
 **
 ** This file may be used under the terms of the GNU Lesser General Public
 ** License version 2.1 as published by the Free Software Foundation and
 ** appearing in the file LICENSE.LGPL included in the packaging of this file.
 ** Please review the following information to ensure the GNU Lesser General
 ** Public License version 2.1 requirements will be met:
 ** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
 **
 ** In addition, as a special exception, Nokia gives you certain additional
 ** rights. These rights are described in the Nokia Qt LGPL Exception
 ** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
 **
 ** Other Usage
 **
 ** Alternatively, this file may be used in accordance with the terms and
 ** conditions contained in a signed written agreement between you and Nokia.
 **
 ** If you have questions regarding the use of this file, please contact
 ** Nokia at info@qt.nokia.com.
 ****************************************************************************/

#ifndef CUBI_PATTERNBASE_P_H
#define CUBI_PATTERNBASE_P_H

CUBI_BEGIN_NAMESPACE

/*! \cond DOCUMENT_DATA_CLASSES */
class PatternBaseData : public QSharedData
{

public:
	virtual ~PatternBaseData();
	virtual PatternBaseData * clone();
	virtual bool operator==(const PatternBaseData *other) const;
	virtual QString sparql(Options::SparqlOptions options) const;
	virtual bool isExists() const;
	virtual bool isPattern() const;
	virtual bool isPatternGroup() const;
	virtual bool isGraph() const;
	virtual bool isUnion() const;
	virtual bool isCompositionalSelect() const;
	virtual PatternBase::Type type() const;
	virtual bool isValid() const;
};
/*! \endcond */

CUBI_END_NAMESPACE

template<> Cubi::PatternBaseData *QSharedDataPointer<Cubi::PatternBaseData>::clone();

#endif
